﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
 
    /// <summary>
    ///  接口名称
    /// </summary>
    public class MarkAttribute : Attribute
    {
        private string _name;

        public MarkAttribute(string name)
        {
            this._name = name;
        }

        public string Name
        {
            get { return _name; }
        }
    }

    public class Key : Attribute
    {
        private string _name;

        public Key(string name)
        {
            this._name = name;
        }

        public string Name
        {
            get { return _name; }
        }
    }

    public class OtherAttribute : Attribute
    {
        private string _name;

        public OtherAttribute(string name)
        {
            this._name = name;
        }

        public string Name
        {
            get { return _name; }
        }
    }

    /// <summary>
    /// 用于webapi数据是否加密
    /// </summary>
    public class Jm : Attribute{ }

    /// <summary>
    /// 用于webapi数据是否验证
    /// </summary>
    public class Yz : Attribute { }

}
