﻿using Newtonsoft.Json;

namespace Common
{
    public static class JsonExtension
    {
        public static T TryJsonToT<T>(this string data)
            where T : class, new()
        {
            if (data.ToString().IsJson())
                return JsonConvert.DeserializeObject<T>(data);
            return default(T);
        }

        /// <summary>
        /// 不过判断
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="data"></param>
        /// <returns></returns>
        public static T TryJsonToTNoD<T>(this string data)
           where T : class, new()
        {
                return JsonConvert.DeserializeObject<T>(data);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        public static string TryToJson(this object data)
        {
            return data is string ? data.ToString() : JsonConvert.SerializeObject(data);
        }

      

        
    }



}
