﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{

    #region 分布
    public class Zsfb
    {
        /// <summary>
        /// 是否是振幅  振幅：后台自己生成的数据
        /// </summary>
        public bool IsZf { get; set; }
        /// <summary>
        /// 组选
        /// </summary>
        public ZxEnum Zx { get; set; }

        /// <summary>
        /// 号码
        /// </summary>
        public int Number { get; set; }

        /// <summary>
        /// 计数Number
        /// </summary>
        public int JsNumber { get; set; }

        #region html特性 class等标签特换
        /// <summary>
        /// 样式名称（自定义）
        /// </summary>
        public string ClassName { get; set; }

        /// <summary>
        /// 分组名称
        /// </summary>
        public string LgroupName { get; set; }

        /// <summary>
        /// 颜色
        /// </summary>
        public string LcolorName { get; set; }
        #endregion
    }
    public enum ZxEnum
    {
        组三 = 1,
        组六 = 2,
        豹子 = 3,
    }

    public class ZsModel
    {
        /// <summary>
        /// 期数
        /// </summary>
        public int Qi { get; set; }

        /// <summary>
        /// 号码  
        /// </summary>
        public List<int> Number { get; set; }

        /// <summary>
        /// 类型
        /// </summary>
        public ZsFbEnum ZsFbType { get; set; }

        /// <summary>
        /// 序号
        /// </summary>
        public int Seq { get; set; }
    }


    public enum ZsFbEnum
    {
        全匹配 = 1,
        单一匹配 = 2
    }
    public class ZsfbDTO
    {
        /// <summary>
        /// 期数
        /// </summary>
        public int Qi { get; set; }

        /// <summary>
        /// 走势副本
        /// </summary>

        public List<Zsfb> Zsfb { get; set; }
    }
    #endregion

    #region 遗漏
    public class Yl {
        /// <summary>
        /// 出现集合
        /// </summary>
        public List<int> CxList { get; set; }

        /// <summary>
        /// 最大遗漏
        /// </summary>
        public List<int> MaxList { get; set; }

        /// <summary>
        /// 遗漏次数
        /// </summary>
        public List<int> CsList { get; set; }

        /// <summary>
        /// 连出次数
        /// </summary>
        public List<int> LcList { get; set; }
    }

   
    #endregion
}
